function OptionNameString(str)
	return THEME:GetString('OptionNames',str)
end

function Actor:xyz(xpos,ypos,zpos)
	self:xy(xpos,ypos):z(zpos)
	return self
end
GameColor = {
	PlayerColors = {
		PLAYER_1	= color("#DB3333"),
		PLAYER_2	= color("#33B9DB"),
	},
	PlayerDarkColors = {
		PLAYER_1	= color("#B71414"),
		PLAYER_2	= color("#1496B7"),
	},
	Difficulty = {
		--[[ These are for 'Custom' Difficulty Ranks. It can be very  useful
		in some cases, especially to apply new colors for stuff you
		couldn't before. (huh? -aj) ]]
		Beginner	= color("#C57D39"),			
		Easy		= color("#F7E16E"),			
		Medium		= color("#76C539"),			
		Hard		= color("#39C58F"),			
		Challenge	= color("#397FC5"),			
		Edit		= color("#ACBAC7"),
		Couple		= color("#ACBAC7"),		
		Routine		= color("#ACBAC7"),	
		--[[ These are for courses, so let's slap them here in case someone
		wanted to use Difficulty in Course and Step regions. ]]
		Difficulty_Beginner	= color("#C57D39"),		-- purple
		Difficulty_Easy		= color("#F7E16E"),		-- green
		Difficulty_Medium	= color("#76C539"),		-- yellow
		Difficulty_Hard		= color("#39C58F"),		-- red
		Difficulty_Challenge	= color("#397FC5"),	-- light blue
		Difficulty_Edit 	= color("#ACBAC7"),	-- gray
		Difficulty_Couple	= color("#ACBAC7"),	-- hot pink
		Difficulty_Routine	= color("#ACBAC7")		-- orange
	},
	Stage = {
		Stage_1st	= color("#26BF99"),
		Stage_2nd	= color("#26BF99"),
		Stage_3rd	= color("#26BF99"),
		Stage_4th	= color("#26BF99"),
		Stage_5th	= color("#26BF99"),
		Stage_6th	= color("#26BF99"),
		Stage_Next	= color("#26BF99"),
		Stage_Final	= color("#26BF99"),
		Stage_Extra1	= color("#26BF99"),
		Stage_Extra2	= color("#26BF99"),
		Stage_Nonstop	= color("#26BF99"),
		Stage_Oni	= color("#26BF99"),
		Stage_Endless	= color("#26BF99"),
		Stage_Event	= color("#26BF99"),
		Stage_Demo	= color("#26BF99")
	},
	Judgment = {
		JudgmentLine_W1		= color("#A4CBE9"),
		JudgmentLine_W2		= color("#C3AA5E"),
		JudgmentLine_W3		= color("#8CED91"),
		JudgmentLine_W4		= color("#EDBB8C"),
		JudgmentLine_W5		= color("#8C9CED"),
		JudgmentLine_Held	= color("#FFFFFF"),
		JudgmentLine_Miss	= color("#ED8C8C"),
		JudgmentLine_MaxCombo	= color("#F7E16E")
	},
};

GameColor.Difficulty["Crazy"] = GameColor.Difficulty["Hard"];
GameColor.Difficulty["Freestyle"] = GameColor.Difficulty["Easy"];
GameColor.Difficulty["Nightmare"] = GameColor.Difficulty["Challenge"];
GameColor.Difficulty["HalfDouble"] = GameColor.Difficulty["Medium"];

LoadModule("Row.Prefs.lua")(LoadModule("Options.Prefs.lua"))

function thified_curstage_index(on_eval)
	local numbered_stages= {
		Stage_1st= true,
		Stage_2nd= true,
		Stage_3rd= true,
		Stage_4th= true,
		Stage_5th= true,
		Stage_6th= true,
		Stage_Next= true
	}
	local cur_stage= GAMESTATE:GetCurrentStage()
	local adjust= 1
	-- hack: ScreenEvaluation shows the current stage, but it needs to show
	-- the last stage instead.  Adjust the amount.
	if on_eval then
		adjust= 0
	end
	if numbered_stages[cur_stage] then
		return FormatNumberAndSuffix(GAMESTATE:GetCurrentStageIndex() + adjust)
	else
		return ToEnumShortString(cur_stage)
	end
end

function rec_print_children(parent, indent)
	if not indent then indent= "" end
	if #parent > 0 and type(parent) == "table" then
		for i, c in ipairs(parent) do
			rec_print_children(c, indent .. i .. "->")
		end
	elseif parent.GetChildren then
		local pname= (parent.GetName and parent:GetName()) or ""
		local children= parent:GetChildren()
		Trace(indent .. pname .. " children:")
		for k, v in pairs(children) do
			if #v > 0 then
				Trace(indent .. pname .. "->" .. k .. " shared name:")
				rec_print_children(v, indent .. pname .. "->")
				Trace(indent .. pname .. "->" .. k .. " shared name over.")
			else
				rec_print_children(v, indent .. pname .. "->")
			end
		end
		Trace(indent .. pname .. " children over.")
	else
		local pname= (parent.GetName and parent:GetName()) or ""
		Trace(indent .. pname .. "(" .. tostring(parent) .. ")")
	end
end

function check_stop_course_early()
	return course_stopped_by_pause_menu
end